Unit SF60R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SF60R(K :Integer; RLAM :Real; var T :Array of Real;
                var P :Real);

implementation

procedure SF60R(K :Integer; RLAM :Real; var T :Array of Real;
                var P :Real);
var
K1,I,JJ,ICNT,KCNT,L,J :Integer;
X,Y,P1,ALEPS,X2,Y2,G,H,P2,PE :Extended;
const
EPS :Real = 1.0e-12;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
K1 := K+1;
for I:=1 to K1 do
 begin
  T[I-1] := 0.0;
_1:
 end;
ALEPS := Ln(EPS);
if ( RLAM > 0.0 ) 
 then goto _2;
PE := 1.e0;
T[0] := 1.0;
goto _12;
_2:
X := RLAM;
Y := 1.e0;
JJ := 1;
P1 := -RLAM;
ICNT := Trunc( P1/ALEPS );
P1 := P1-(ICNT)*ALEPS;
P1 := Exp(P1);
X2 := K;
Y2 := RLAM;
G := X2*Ln(Y2);
H := 1.e0;
for L:=1 to K do
 begin
_3:
  H := H*(L);
 end;
H := Ln(H);
P2 := -Y2+G-H;
KCNT := Trunc( P2/ALEPS );
P2 := P2-(KCNT)*ALEPS;
P2 := Exp(P2);
G := 1.e0;
H := 1.e0;
if ( ICNT = 0 ) 
 then G := 1.e0-P1;
if ( KCNT = 0 ) 
 then H := 1.e0-P2;
PE := 0.e0;
_4:
J := ICNT-KCNT;
if ( J ) < 0
 then goto _9
 else if ( J ) > 0
       then goto _6
       else goto _5;
_5:
if ( P1 > P2 ) 
 then goto _9;
_6:
if ( ICNT <> 0 ) 
 then goto _7;
T[JJ-1] := P1;
PE := PE+P1;
_7:
if ( JJ = K1 ) 
 then goto _12;
P1 := P1*X/Y;
if ( P1 < H ) 
 then goto _8;
P1 := P1*EPS;
ICNT := ICNT-1;
_8:
JJ := JJ+1;
Y := Y+1.e0;
goto _4;
_9:
if ( KCNT <> 0 ) 
 then goto _10;
T[K1-1] := P2;
PE := PE+P2;
_10:
if ( JJ = K1 ) 
 then goto _12;
P2 := P2*X2/Y2;
if ( P2 < G ) 
 then goto _11;
P2 := P2*EPS;
KCNT := KCNT-1;
_11:
K1 := K1-1;
X2 := X2-1.e0;
goto _4;
_12:
P := PE;
end;

end.
